%define name	kaffe
%define version	1.0.6
%define release	8mdk

Summary:	A free virtual machine for running Java(TM) code
Name:		%{name}
Version:	%{version}
Release:	%{release}
Epoch:		2
License:	GPL
Url:		http://www.kaffe.org/
Group:		Development/Java

Source0:	ftp://ftp.transvirtual.com/pub/kaffe/kaffe-%{version}.tar.bz2
Patch:		kaffe-alpha.patch.bz2
Patch2:		kaffe-1.0.6-perlpath.patch.bz2
Patch3:		kaffe-1.0.6.mdk.patch.bz2
Patch4:		kaffe-1.0.6.mdk.keypad.patch.bz2
Patch5:		kaffe-1.0.6.mdk.font.patch.bz2
Patch6:		kaffe-1.0.6.mdk.focus.patch.bz2
Patch11:	kaffe-getBytes.patch.bz2
Patch12:	kaffe-sparc.patch.bz2
Patch13:	kaffe-1.0.6-jlong.patch.bz2
Patch14:	kaffe-gc-incremental.patch.bz2
Patch15:	kaffe-1.0.6.mdk.glibc22.patch.bz2

Obsoletes:	kaffe-bissawt
Buildroot:	%{_tmppath}/%name-%version-root
BuildConflicts:	jikes
%ifarch ppc
BuildRequires:	libffi
%endif

%description
Kaffe is a free virtual machine designed to execute Java(TM) bytecode.
Kaffe can be configured in two modes.  In the first mode, it operates
as a pure bytecode interpreter (not unlike Javasoft's machine).  In
the second mode, it performs "just-in-time" code conversion from the
abstract code to the host machine's native code.  The second mode will
ultimately allow execution of Java code at the same speed as standard
compiled code, while also maintaining the advantages and flexibility
of code independence.

Install the kaffe package if you need a Java virtual machine.

%package devel
Summary: Development package with static libs and headers for kaffe.
Group: Development/C
Requires: %{name} = %{version}

%description devel
This package contains the static libraries, header files and documentation
necessary for development of programs that will use kaffe.

You should install this package if you need to develop programs which
will use kaffe functions.
You'll also need to install kaffe package.

%prep
%setup -q -n kaffe-%{version}
rm -f configure.in
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch11 -p1
%patch12 -p1 -b .sparc
%patch13 -p1 -b .jlong
%patch14 -p1 -b .gc
%patch15 -p2

%build
KAFFE_OPT_FLAGS=$(echo $RPM_OPT_FLAGS|sed 's/-fomit-frame-pointer//')
CFLAGS="$KAFFE_OPT_FLAGS"

%configure --disable-gcj \
	   --libdir=%{_libdir}/kaffe \
	   --libexecdir=%{_libdir}/kaffe \
	   --disable-rpath

find . -type 'd' -name "CVS" -print | xargs /bin/rm -rf

# hugly world <yves>
cd %_builddir/%{name}-%{version}/libraries/clib/zip
perl -pi -e 's,LIBS =  -L/usr/local/lib   -R/usr/local/lib,LIBS =  -L/usr/local/lib ,;' Makefile
cd %_builddir/%{name}-%{version}/libraries/clib/security
perl -pi -e 's,LIBS =  -L/usr/local/lib   -R/usr/local/lib,LIBS =  -L/usr/local/lib ,;' Makefile
cd %_builddir/%{name}-%{version}/libraries/clib/net
perl -pi -e 's,LIBS =  -L/usr/local/lib   -R/usr/local/lib,LIBS =  -L/usr/local/lib ,;' Makefile
cd %_builddir/%{name}-%{version}/libraries/clib/native
perl -pi -e 's,LIBS =  -L/usr/local/lib   -R/usr/local/lib,LIBS =  -L/usr/local/lib ,;' Makefile
cd %_builddir/%{name}-%{version}/libraries/clib/math
perl -pi -e 's,LIBS =  -L/usr/local/lib   -R/usr/local/lib,LIBS =  -L/usr/local/lib ,;' Makefile
cd %_builddir/%{name}-%{version}/libraries/clib/management
perl -pi -e 's,LIBS =  -L/usr/local/lib   -R/usr/local/lib,LIBS =  -L/usr/local/lib ,;' Makefile
cd %_builddir/%{name}-%{version}/libraries/clib/io
perl -pi -e 's,LIBS =  -L/usr/local/lib   -R/usr/local/lib,LIBS =  -L/usr/local/lib ,;' Makefile
cd %_builddir/%{name}-%{version}/libraries/clib/awt/X
perl -pi -e 's,LIBS =  -L/usr/local/lib   -R/usr/local/lib,LIBS =  -L/usr/local/lib ,;' Makefile
perl -pi -e 's,X_LIBS =  -L/usr/X11R6/lib -R/usr/X11R6/lib,X_LIBS = -L/usr/X11R6/lib,;' Makefile
perl -pi -e 's,-R/usr/X11R6/lib,,;' Makefile
cd %_builddir/%{name}-%{version}/libraries/extensions/microsoft/clib
perl -pi -e 's,LIBS =  -L/usr/local/lib   -R/usr/local/lib,LIBS =  -L/usr/local/lib ,;' Makefile
cd %_builddir/%{name}-%{version}/kaffe/kaffe
perl -pi -e 's,LIBS =  -L/usr/local/lib   -R/usr/local/lib,LIBS =  -L/usr/local/lib ,;' Makefile
perl -pi -e 's,X_LIBS =  -L/usr/X11R6/lib -R/usr/X11R6/lib,X_LIBS = -L/usr/X11R6/lib,;' Makefile
cd %_builddir/%{name}-%{version}/kaffe/kaffeh
perl -pi -e 's,LIBS =  -L/usr/local/lib   -R/usr/local/lib,LIBS =  -L/usr/local/lib ,;' Makefile
cd %_builddir/%{name}-%{version}/kaffe/kaffevm
perl -pi -e 's,LIBS =  -L/usr/local/lib   -R/usr/local/lib,LIBS =  -L/usr/local/lib ,;' Makefile
perl -pi -e 's,X_LIBS =  -L/usr/X11R6/lib -R/usr/X11R6/lib,X_LIBS = -L/usr/X11R6/lib,;' Makefile
cd %_builddir/%{name}-%{version}/kaffe/xprof
perl -pi -e 's,LIBS =  -L/usr/local/lib   -R/usr/local/lib,LIBS =  -L/usr/local/lib ,;' Makefile
cd %_builddir/%{name}-%{version}

%make all
%make Klasses

%install
rm -rf $RPM_BUILD_ROOT

%makeinstall \
	libdir=$RPM_BUILD_ROOT%{_libdir}/kaffe \
	libexecdir=$RPM_BUILD_ROOT%{_libdir}/kaffe \
	nativedir=$RPM_BUILD_ROOT%{_libdir}/kaffe \
	classdir=$RPM_BUILD_ROOT%{_datadir}/kaffe

%clean
rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc README FAQ license.terms
%{_mandir}/*/*
%{_libdir}/kaffe/Kaffe
%{_bindir}/*
%{_libdir}/kaffe/*.so
%{_datadir}/kaffe

%files devel
%defattr(-,root,root)
%doc README developers
%{_includedir}/kaffe
#%{_libdir}/kaffe/*.so
%{_libdir}/kaffe/*.la

%changelog
* Tue Jul 17 2001 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.0.6-8mdk
- spec file sanitizification (s/Serial/Epoch, s/Copyright/License)
- split %%make all Klasses

* Tue Feb 27 2001 Jeff Garzik <jgarzik@mandrakesoft.com> 1.0.6-7mdk
- Fix build with new glibc (more strict headers)

* Thu Jan  4 2001 Yves Duret <yduret@mandrakesoft.com> 1.0.6-6mdk
- put back some lib in main package

* Wed Jan  3 2001 Yves Duret <yduret@mandrakesoft.com> 1.0.6-5mdk
- disable gcj support, since it breaks with gcc 2.96
- devel related stuff moved to -devel package
- clean up the spec file

* Fri Oct 27 2000 David BAUDENS <baudens@mandrakesoft.com> 1.0.6-4mdk
- Fix build on PPC

* Fri Oct 13 2000 Stefan van der Eijk <s.vandereijk@chello.nl> 1.0.6-3mdk
- made Buildroot standard
- remove configure.in in %%prep to make go with %%configure in pinstripe (RH)
- removed alpha patch (RH)
- added getBytes patch (RH)
- added sparc patch (RH)
- added jlong patch (otherwise won't compile on alpha) (RH)
- added gc-incremental patch (Kaffe ML)
- removed old commented stuff
- macro's (configure, make, makeinstall)
- let spec helper do it's job (compressing & stripping)

* Mon Sep 25 2000 Maurizio De Cecco <maurizio@mandrakesoft.com> 1.0.6-2mdk
- removed CVS junk

* Mon Aug 8 2000 Maurizio De Cecco <maurizio@mandrakesoft.com> 1.0.6-1mdk
- Moved to kaffe 1.0.6
- Remove those patches that have been incoporated with the official kaffe distribution
- fixed man/lib/bin path according to the FHS.

* Fri May 26 2000 David BAUDENS <baudens@mandrakesoft.com> 1.0.5-11mdk
- BuildConflicts: jikes
- Use %%{_tmppath} for BuildRoot

* Fri May  5 2000 Maurizio De Cecco <maurizio@mandrakesoft.com>
- 10mdk
- Removed jpeg patch added in 8mdk; the libjpeg/autoconf problem
  has been fixed in libjeg-14mdk

* Wed Apr 26 2000 Maurizio De Cecco <maurizio@mandrakesoft.com>
- 9mdk
- Fixed bug in AWT focus handling.

* Mon Apr 20 2000 Maurizio De Cecco <maurizio@mandrakesoft.com>
- 8mdk
- Patched to force jpeg support inclusion, to cope with a bug/incompatibility
  between libjpeg and autoconf.

* Mon Apr 17 2000 Maurizio De Cecco <maurizio@mandrakesoft.com>
- 7mdk
- Fixed memory corruption problem in FontMetrics/XFontStruct.

* Thu Apr 13 2000 Maurizio De Cecco <maurizio@mandrakesoft.com>
- Really Added patch to fix kaffe behavoiur with the Keypad.

* Wed Apr 12 2000 Maurizio De Cecco <maurizio@mandrakesoft.com>
- Added patch to fix kaffe behavoiur with the Keypad.

* Tue Apr 11 2000 Maurizio De Cecco <maurizio@mandrakesoft.com>
- Fixed Distribution name

* Tue Mar 28 2000 Maurizio De Cecco <maurizio@mandrakesoft.com>
- Fixed a bug in key event handling.

* Tue Mar 14 2000 Maurizio De Cecco <maurizio@mandrakesoft.com>
- Added Mandrake Patches for Process, TextField and TextComponent classes
- Upgraded the kjc compiler to version 1.4C.
- Modified build process to rebuild the patched class library
- Adapted to the new group structure

* Tue Oct 26 1999 Maurizio De Cecco <maurizio@mandrakesoft.com>
- Mandrake version for 1.05

* Mon Oct 18 1999 Bill Nottingham <notting@redhat.com>
- 1.0.5. Lets see what it does.

* Mon Apr 12 1999 Bill Nottingham <notting@redhat.com>
- build for alpha (it seems to work...)
- fix paths so it works

* Mon Apr 12 1999 Preston Brown <pbrown@redhat.com>
- according to the kaffe people, b4 is a "massive bugfix release"

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 4)

* Thu Mar 18 1999 Bill Nottingham <notting@redhat.com>
- strip binaries

* Tue Dec 15 1998 Bill Nottingham <notting@redhat.com>
- add an Obsoletes: for kaffe-bissawt

* Wed Dec  9 1998 Bill Nottingham <notting@redhat.com>
- update to 1.0b3
- include alpha patch, but it's still broke

* Mon Oct 05 1998 Cristian Gafton <gafton@redhat.com>
- added sparc to the list of supported architectures
- update to 1.0b2

* Tue Sep 22 1998 Bill Nottingham <notting@redhat.com>
- don't rename libraries; install them in /usr/lib/kaffe
- remove sparc arch (doesn't work)

* Thu Jul 23 1998 Jeff Johnson <jbj@redhat.com>
- update to 1.0.b1.
- add sparc arch (alpha has problems kaffe/kaffeevm/support.c:{343,518}

* Fri May 08 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Mon May 04 1998 Cristian Gafton <gafton@redhat.com>
- finally their ftp site is up again: updated to 0.10.0
- too bad the Biss-AWT doesn't seem to be maintained anymore... Removed the
  bissawt package
- unfortunately alpha and sparc assembler code that reference registers
  like eax, ebx, etc. makes this package ExclusiveArch: i386

* Tue Dec 09 1997 Cristian Gafton <gafton@redhat.com>
- added kaffe to the file list
- added BuildRoot; cleaned the spec file

* Tue Nov 11 1997 Michael K. Johnson <johnsonm@redhat.com>
- removed pieces with incompatible licenses

* Tue Oct 21 1997 Erik Troan <ewt@redhat.com>
- updated to 0.9.2

* Mon Aug 25 1997 Erik Troan <ewt@redhat.com>
- built against glibc

* Thu Apr 24 1997 Erik Troan <ewt@redhat.com>
- added libkaffe_vm.so symlink.

* Tue Apr 22 1997 Erik Troan <ewt@redhat.com>
- added manual provide of libkaffe_vm.so (RPM seems a bit broken).
